# -*- encoding: utf-8 -*-
# pylint: disable=E0203,E1101,C0111
"""
@file
@brief Runtime operator.
"""
import numpy
from ._op import OpRunReduceNumpy


class ReduceLogSum(OpRunReduceNumpy):

    atts = {'axes': [], 'keepdims': 1}

    def __init__(self, onnx_node, desc=None, **options):
        OpRunReduceNumpy.__init__(self, onnx_node, desc=desc,
                                  expected_attributes=ReduceLogSum.atts,
                                  **options)

    def _run(self, data, verbose=0, fLOG=None):  # pylint: disable=W0221
        tax = tuple(self.axes) if self.axes else None
        res = numpy.sum(data, axis=tax, keepdims=self.keepdims)
        if len(res.shape) > 0:
            return (numpy.log(res, out=res), )
        return (numpy.log(res), )
